#include "stc_timer.h"
#include "ucp_drv_common.h"
#include "ucp_utility.h"
#include "ucp_printf.h"
#include "inter_vector.h"

void stc_timer_todint_init(void)
{
	int32_t apeId = get_core_id();

	TOD_REG_IRQ_EN |= 0x1;		// set tod int enable

	uint32_t intNum = APC_STC_INTR8;
	// attach interrupt func
	int32_t ret = smart_irq_request(intNum, isr_stc_tod_int);
	if (0 != ret)
	{
		UCP_PRINT_ERROR("attach int num: 0x%x error. errno = 0x%x. \r\n", intNum, ret);
		debug_write(DBG_DDR_ERR_IDX(apeId, 8), ret);
	}
}

uint32_t gTodLastStcCnt = 0;
uint32_t gTodIntCnt = 0;
void isr_stc_tod_int()
{
	int32_t status = do_read_volatile(&TOD_REG_INT_STATUS);
	__ucps2_synch(0);
	if (status & 0x1)
	{
		do_write((&TOD_REG_INT_STATUS), 0x1);

		if (0 < gTodIntCnt)
		{
			uint64_t temp = do_read_volatile(0x04a80008) + 0xFFFFFFFF;
			uint32_t period = temp - gTodLastStcCnt;
			debug_write(((DBG_DDR_IDX_DRV_BASE+1088)+((gTodIntCnt-1)&0x3F)), period);	// 0x1000
		}
		gTodLastStcCnt = do_read_volatile(0x04a80008);

		gTodIntCnt++;

		debug_write((DBG_DDR_IDX_DRV_BASE+64), gTodIntCnt); // 0x100

		status = do_read_volatile(&TOD_REG_INT_STATUS);
	}
}



